﻿// This editor provider demonstrates how to wrap HTML 5 number INPUT into editor provider for the igGridUpdating

$(function () {
    if ($.ig == null)
        return;

    $.ig.MultiLineEditor = $.ig.MultiLineEditor || $.ig.EditorProviderBase.extend({
        createEditor: function (callbacks, key, editorOptions, tabIndex, format, element) {
            element = element || $("<span />");
            if (!element.igTextEditor) {
                throw new Error($.ig.GridUpdating.locale.igTextEditorException);
            }
            this._super(callbacks, key, editorOptions, tabIndex, format, element);
            this.options.textMode = "multiline";
            element.igTextEditor(this.options);            
            this.editor = element.data("igTextEditor");
            this.textarea = $(element).find("textarea")[0];
            $(this.textarea).addClass("sqs-extendedmultilineeditor");
            return this.editor.editorContainer();
        },

        keyDown: function (evt, ui) {
            // notify Updating that a key has been pressed
            if (this.callbacks && typeof this.callbacks.keyDown === "function") {
                // don't notify if the editor is textarea and alt+enter is pressed
                if (!(ui.key === $.ui.keyCode.ENTER) || !ui.editorInput.is("textarea")) {
                    this.callbacks.keyDown(evt, ui, this.columnKey);
                } else {
                    evt.originalEvent.stopPropagation();
                    this._adjustEditor();
                }
            }
            if (this.userHandlers.keyDown) {
                this.userHandlers.keyDown.apply(this.editor, [evt, ui]);
            }
        },
        // set editor value
        setValue: function (val) {
            var t = val==null ? "" : val;
            this.editor.element.igTextEditor("value",t);
            this._adjustEditor();
            return t;
        },

        _adjustEditor: function () {
            var text = $(this.textarea).val();
            var rows = text.split("\n");
            var lineHeight = 20;
            var tab = $(this.editor.element).closest(".ui-iggrid-scrolldiv");
            var row = $(this.editor.element).closest("tr");
            var rowHeight = $(row).innerHeight();
            var maxHeight = 100;//$(tab).innerHeight();
            var newHeight = lineHeight * (rows.length+2);
            if (newHeight > maxHeight) {
                newHeight = maxHeight;
            }
            if (newHeight < rowHeight) {
                newHeight = rowHeight;
            }
            $(this.editor.element).igTextEditor("option", "height", newHeight);

            var newCols = 0;
            for (var i = 0; i < rows.length; i++) {
                if (rows[i].length > newCols) {
                    newCols = rows[i].length;
                }
            }
            return;
        }


    });

});


